/*
 * generated by Xtext
 */
package hu.bme.mit.socialnetwork.formatting;

import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess;
import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess.AcquaintanceElements;
import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess.CommunityElements;
import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess.PersonElements;
import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess.SocialNetworkElements;

import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class SocialNetworkLanguageFormatter extends AbstractDeclarativeFormatter {
	
	@Override
	protected void configureFormatting(FormattingConfig c) {
// It's usually a good idea to activate the following three statements.
// They will add and preserve newlines around comments
		SocialNetworkLanguageGrammarAccess access = (SocialNetworkLanguageGrammarAccess) getGrammarAccess();
		// It's usually a good idea to activate the following three statements.
		// They will add and preserve newlines around comments
		c.setLinewrap(0, 1, 2).before(access.getSL_COMMENTRule());
		c.setLinewrap(0, 1, 2).before(access.getML_COMMENTRule());
		c.setLinewrap(0, 1, 1).after(access.getML_COMMENTRule());

		SocialNetworkElements sne = access.getSocialNetworkAccess();
		c.setLinewrap(1, 1, 1).after(sne.getLeftCurlyBracketKeyword_1());
		c.setLinewrap(1, 1, 1).before(sne.getRightCurlyBracketKeyword_4());
		c.setLinewrap(1, 1, 1).after(sne.getEntitiesAssignment_2());
		//c.setLinewrap(1, 1, 1).after(sne.getCommaKeyword_5_0());
		c.setLinewrap(2, 2, 2).before(sne.getAcquaintancesAcquaintanceParserRuleCall_3_0());
		c.setIndentationIncrement().after(sne.getLeftCurlyBracketKeyword_1());
		c.setIndentationDecrement().before(sne.getRightCurlyBracketKeyword_4());
		
		CommunityElements ca = access.getCommunityAccess();
		c.setLinewrap(1, 1, 1).after(ca.getLeftCurlyBracketKeyword_2_0());
		c.setLinewrap(1, 1, 2).before(ca.getRightCurlyBracketKeyword_2_3());
		c.setIndentationIncrement().after(ca.getLeftCurlyBracketKeyword_2_0());
		c.setIndentationDecrement().before(ca.getRightCurlyBracketKeyword_2_3());
		
		PersonElements pa = access.getPersonAccess();
		c.setLinewrap(1, 1, 2).before(pa.getMembershipsKeyword_4_0());
		c.setLinewrap(1, 1, 1).before(pa.getSexAssignment_3());
		c.setLinewrap(1, 1, 1).after(pa.getSexAssignment_3());
		c.setLinewrap(1, 1, 1).after(pa.getLeftCurlyBracketKeyword_2());
		c.setLinewrap(1, 1, 1).before(pa.getRightCurlyBracketKeyword_5());
		c.setNoSpace().before(pa.getCommaKeyword_4_2_0());
		c.setIndentationIncrement().after(pa.getLeftCurlyBracketKeyword_2());
		c.setIndentationDecrement().before(pa.getRightCurlyBracketKeyword_5());
		
		AcquaintanceElements aa = access.getAcquaintanceAccess();
		c.setLinewrap(1, 1, 1).after(access.getAcquaintanceRule());
	}
}
